
#include "display.h"


/*****************************************************/

void dispDistSun(int x, int y, int n){
	int tmp;
	int space=0;
	PrintMini(x-space-5,y,"Mm",2);
	space+=15;
	if(n==0){
		ML_bmp_xor_cl(bmp_numbers[0],x-space,y-1,6,7);
		space+=5;
	}
	while( n % 10 >= 0 && n>0 ){
		tmp=n;
		n=(n/10)*10;
		tmp-=n;
		ML_bmp_xor_cl(bmp_numbers[tmp],x-space,y-1,6,7);
		n/=10;
		space+=5;
	}
	PrintMini(x-space-33,y,"Dist.Sun: ",2);
}

void black_vram(){
	ML_rectangle(0,0,ML_SCREEN_WIDTH,ML_SCREEN_HEIGHT,0,ML_BLACK,ML_BLACK);
}

void dispGalaxy(int distanceFromSun){
	unsigned int indP=0;
	int x=(Planets[0].distanceSun-Planets[0].diameter/10E3)-distanceFromSun;
	black_vram();
	
	while(indP<NB_PLANETS){ // x<ML_SCREEN_WIDTH && 
		ML_filled_circle(x,ML_SCREEN_HEIGHT/2,Planets[indP].diameter/10E3,ML_XOR);
		x=(Planets[indP+1].distanceSun/10E3)-distanceFromSun;
		indP++;
	}

	ML_line(MARGIN_LEFT-2,ML_SCREEN_HEIGHT,MARGIN_LEFT,ML_SCREEN_HEIGHT-5,ML_XOR);
	ML_line(MARGIN_LEFT,ML_SCREEN_HEIGHT-5,MARGIN_LEFT+2,ML_SCREEN_HEIGHT,ML_XOR);
	// top arrow
	ML_line(MARGIN_LEFT-2,0,MARGIN_LEFT,5,ML_XOR);
	ML_line(MARGIN_LEFT,5,MARGIN_LEFT+2,0,ML_XOR);
	// bottom arrow
}

void dispPDA(int x, int y, text T, int scroll){
	const unsigned int marginBot=5;
	const unsigned int marginHead=11;
	const unsigned int maxScroll=getMaxScroll(y+marginHead+3,ML_SCREEN_HEIGHT-marginBot,T);
	ML_bmp_and_cl(bmp_pda_transparence,x,y+1,55,y+marginHead);
	ML_bmp_or_cl(bmp_pda,x,y+1,55,y+marginHead);
	ML_horizontal_line(y+10,0,ML_SCREEN_WIDTH,ML_BLACK);
	ML_rectangle(x,y+marginHead,ML_SCREEN_WIDTH,ML_SCREEN_HEIGHT, 0, ML_WHITE, ML_WHITE);
	dispScroll(ML_SCREEN_WIDTH-10,y+marginHead+1,ML_SCREEN_HEIGHT-y-marginHead-marginBot,100*scroll/maxScroll);
	dispText(T, scroll, 5, y+marginHead+3, ML_SCREEN_WIDTH-marginHead, ML_SCREEN_HEIGHT-marginBot, ML_BLACK);
}

void dispScroll(int x, int y, int height, int perc){
	// width : 7px
	if(abs(height-y)>5){
		ML_horizontal_line(y,x+2,x+4,ML_BLACK);
		ML_point(x+1,y+1,1,ML_BLACK);
		ML_point(x+5,y+1,1,ML_BLACK);
		ML_vertical_line(x,y+2,y+height-2,ML_BLACK);
		ML_vertical_line(x+6,y+2,y+height-2,ML_BLACK);
		ML_point(x+1,y+height-1,1,ML_BLACK);
		ML_point(x+5,y+height-1,1,ML_BLACK);
		ML_horizontal_line(y+height,x+2,x+4,ML_BLACK);
		ML_filled_circle(x+3,y+3+(height-6)*perc/100,2,ML_BLACK);
	}
}

//START//
void intro(){
	int scroll=0;
	int iter=0;
	ML_clear_vram();
	ML_bmp_or_cl(bmp_solaris,0,0,ML_SCREEN_WIDTH, ML_SCREEN_HEIGHT);
	ML_display_vram();
	while(!(getKeyUp() || getKeyDown() || getKeyLeft() || getKeyRight() || getKeyExe())){
	}
	while(scroll!=41){ //Scrolling up Transition
		ML_clear_vram();
		ML_rectangle(0,0,scroll,ML_SCREEN_HEIGHT,0,ML_BLACK,ML_BLACK);
		// fills the left gap
		// ML_rectangle(79+41-scroll,22,ML_SCREEN_WIDTH,47,0,ML_BLACK,ML_CHECKER);
		ML_rectangle(79+41-scroll,22,ML_SCREEN_WIDTH,47,0,ML_BLACK,ML_BLACK);
		// hides the text
		ML_bmp_or_cl(bmp_solaris,scroll,0,ML_SCREEN_WIDTH, ML_SCREEN_HEIGHT);
		ML_display_vram();
		iter++;
		scroll=iter%20==0?scroll+1:scroll;
	}
	ML_clear_vram();
	ML_bmp_or_cl(bmp_start,0,0,ML_SCREEN_WIDTH, ML_SCREEN_HEIGHT);
	ML_display_vram();
	PrintMini(20, ML_SCREEN_HEIGHT-10, "GALAXY : MILKY WAY", 2);
	ML_display_vram();
	iter=0;
	while(iter<10E4){iter++;}
	galaxyAnimation();
	iter=0;
	while(iter<10E4){iter++;}
}

void galaxyAnimation(){
	unsigned int iter=0;
	unsigned int frame=0;
	while(frame<12){ // && !getKeyExit()
		iter++;
		if(iter%100000==0){
			ML_clear_vram();
			ML_bmp_or_cl(animation_galaxy[frame],0,0,ML_SCREEN_WIDTH,ML_SCREEN_HEIGHT);
			ML_display_vram();
			frame++;
		}
	}
}

void dispPlanet(unsigned int indP){
	ML_bmp_xor_cl(bmp_planets[indP],0,0,63,65);
}

void dispInfoPlanet(unsigned int indP, unsigned int scroll){
	text T;
	unsigned char* text[12];
	char diameter[50];
	char distanceSun[50];
	char avgTemp[50];
	char mass[50];
	char density[50];
	char gravity[50];
	sprintf(diameter,"%d km",Planets[indP].diameter);
	sprintf(distanceSun, "%d Mm", Planets[indP].distanceSun);
	sprintf(avgTemp, "%d `C", Planets[indP].temperature);
	sprintf(mass, "%g*10E23 kg", Planets[indP].mass);
	sprintf(density, "%g gm/cm3", Planets[indP].density);
	sprintf(gravity, "%g", Planets[indP].gravity);
	text[0]="Diameter :";
	text[1]=diameter;
	text[2]="Distance sun :";
	text[3]=distanceSun;
	text[4]="Avg temp :";
	text[5]=avgTemp;
	text[6]="Mass :";
	text[7]=mass;
	text[8]="Density :";
	text[9]=density;
	text[10]="Gravity :";
	text[11]=gravity;
	T.str=text;
	T.len=12;
	PrintXY(70,5,Planets[indP].name, ML_XOR);
	dispText(T, scroll, 65, 20, ML_SCREEN_WIDTH-5, ML_SCREEN_HEIGHT-5, ML_XOR);
}

void explanations(){
	unsigned short int i=0;
	int transitionScroll=ML_SCREEN_HEIGHT+1;

	int maxScroll=0;
	int scroll=0;
	const int marginLeft=10;
	const int marginTop=10;
	const int marginBottom=10;
	text T;
	unsigned char *text[] = {
		"Welcome !",
		"Together we will discover",
		"our solar system.",
		"By moving with the side",
		"arrows and pressing enter",
		"you will be able to access",
		"lots of informations",
		"concerning the planets that",
		"surround ours.",
		"We wish you a great",
		"experience !"
	};
	T.str=text;
	T.len=11;
	maxScroll=getMaxScroll(13,ML_SCREEN_HEIGHT-5,T);

	while(transitionScroll>=0){
		dispPDA(0,transitionScroll,T,scroll);
		ML_display_vram();
		transitionScroll=(i%20==0)?transitionScroll-1:transitionScroll;
	}

	do{

		unsigned int key;

		GetKey(&key);
		switch (key) {
			case KEY_CTRL_DOWN:
			if(scroll<maxScroll) scroll++;
			break;
			case KEY_CTRL_UP:
			if(getKeyUp() && scroll>0) scroll--;
			break;
			default:break;
		}
		if(key==KEY_CTRL_DOWN || key==KEY_CTRL_UP){
			ML_clear_vram();
			ML_bmp_and_cl(animation_galaxy[11],0,0,ML_SCREEN_WIDTH,ML_SCREEN_HEIGHT);
			ML_bmp_or_cl(animation_galaxy[11],0,0,ML_SCREEN_WIDTH,ML_SCREEN_HEIGHT);
			dispPDA(0,0,T,scroll);
			ML_display_vram();
		}

	} while(!(getKeyExit() || getKeyMenu() || getKeyExe()));

	i=0;
	while(transitionScroll<=ML_SCREEN_HEIGHT+1){
		dispGalaxy(Planets[1].distanceSun/10E3-MARGIN_LEFT);
		dispPDA(0,transitionScroll,T,scroll);
		ML_display_vram();
		transitionScroll=(i%20==0)?transitionScroll+1:transitionScroll;
	}

}

void dispText(text T, int scroll, int x, int y, int xM, int yM, ML_Color color){
	int i, j;
	unsigned int line=y;
	unsigned int p=0;
	i=scroll;
	while(i < T.len && line<yM){
		j = 0;
		p=0;
		switch(color){
			case ML_BLACK:
			PrintMini(x, line, T.str[i], 0);
			break;
			case ML_WHITE:
			PrintMini(x, line, T.str[i], 1);
			break;
			case ML_XOR:
			PrintMini(x, line, T.str[i], 2);
			break;
		}
		// for (j = 0; j < strlen(T.str[i]); j++){
		// 	printc(T.str[i][j], x+j*4, y+line);
			// if(j*4 > abs(xM-x) ){ //|| j==strlen(T.str[i])
		line+=LINE_SPACING;
			// }
		// }
		i++;
	}
}

int getMaxScroll(int y, int yMax, text T){
	return T.len-(abs(yMax-y)/LINE_SPACING);
}

// void printc(const unsigned char c, int x, int y) {
// 	unsigned char str[1];
// 	str[0]=c;
// 	PrintMini(x, y, str, 0);
// }

void dispPause(unsigned short int choice){
	const unsigned int x=42;
	const unsigned int y=15;
	ML_rectangle(x, y, x+40, y+35, 1, ML_BLACK, ML_WHITE);
	// int x, int y, unsigned char *, int color
	PrintXY(x+5, y+2, "Pause",0);
	PrintMini(x+5+3, y*2, "Resume",0); // 31px
	PrintMini(x+5+8, y*2+10, "Quit",0); // 15px
	ML_rectangle(x, (choice)*10+y*2-1, x+40, (choice)*10+y*2+6, 0, ML_TRANSPARENT, ML_XOR);
}