#ifndef DISPLAY_H
#define DISPLAY_H

#include "MonochromeLib.h"
#include <fxlib.h>
#include <stdio.h>
// #include <stdlib.h>

#include "sprites.h"
#include "planets.h"
// #include "character.h"
// #include "general.h"
// #include "levels.h"

#define MARGIN_LEFT 50
#define LINE_SPACING 7

typedef struct {
	unsigned char *sprite;
	int length;
	int height;
} bmp;

typedef struct {
	unsigned char **str;
	unsigned int len;
} text;

void dispDistSun(int x, int y, int n);


void black_vram();
void dispGalaxy(int distanceFromSun);
void dispPDA(int x, int y, text T, int scroll);
void dispScroll(int x, int y, int height, int perc);
void intro();
void galaxyAnimation();

void dispPlanet(unsigned int indP);
void dispInfoPlanet(unsigned int indP, unsigned int scroll);

void explanations();

void dispText(text T, int scroll, int x, int y, int xM, int yM, ML_Color color);
int getMaxScroll(int y, int yMax, text T);
// void printc(const unsigned char C, int x, int y);

void dispPause(unsigned short int choice);

#endif // DISPLAY_H