/*****************************************************************/
/*                                                               */
/*   CASIO fx-9860G SDK Library                                  */
/*                                                               */
/*   File name : [ProjectName].c                                 */
/*                                                               */
/*   Copyright (c) 2006 CASIO COMPUTER CO., LTD.                 */
/*                                                               */
/*****************************************************************/

#include "main.h"


//****************************************************************************
//  AddIn_main (Sample program main function)
//
//  param   :   isAppli   : 1 = This application is launched by MAIN MENU.
//                        : 0 = This application is launched by a strip in eACT application.
//
//              OptionNum : Strip number (0~3)
//                         (This parameter is only used when isAppli parameter is 0.)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int AddIn_main(int isAppli, unsigned short OptionNum) {

	unsigned int key;
	unsigned int choice = 1;
	int scroll = Planets[choice].distanceSun/10E3-MARGIN_LEFT;
	int newScroll = 0;
	short int quit=0;

	unsigned int i=0;

	intro();
	explanations();

	do{
		ML_clear_vram();
		dispGalaxy(scroll);
		PrintMini(1,1,Planets[choice].name,2);
		dispDistSun(ML_SCREEN_WIDTH-7,ML_SCREEN_HEIGHT-7,Planets[choice].distanceSun/10E3);
		ML_display_vram();

		GetKey(&key);
		switch (key) {

			case KEY_CTRL_LEFT:
			choice=choice>0?choice-1:choice;
			break;

			case KEY_CTRL_RIGHT:
			choice=choice<NB_PLANETS-1?choice+1:choice;
			break;

			case KEY_CTRL_EXE:
			showInfos(choice);
			break;

			case KEY_CTRL_MENU:
			case KEY_CTRL_EXIT:
			quit=pause();
			break;
			
			default:break;
		}

		if(key==KEY_CTRL_LEFT || key==KEY_CTRL_RIGHT){
			newScroll = Planets[choice].distanceSun/10E3-MARGIN_LEFT;
			i=0;
			do{
				ML_clear_vram();
				dispGalaxy(scroll);
				dispDistSun(ML_SCREEN_WIDTH-7,ML_SCREEN_HEIGHT-7,scroll+MARGIN_LEFT);
				ML_display_vram();
				if(i%2==0) 
					scroll=newScroll>scroll?scroll+1:scroll-1;
				i++;
			} while(scroll!=newScroll);
			PrintMini(1,1,Planets[choice].name,2);
			ML_display_vram();
		}

	} while(!quit);

	return 1;
}


int pause(){
	unsigned int key;
	unsigned short int choice=0;
	do{
		dispPause(choice);
		GetKey(&key);
		switch(key){
			case KEY_CTRL_UP:
			choice=0; // resume
			break;
			case KEY_CTRL_DOWN:
			choice=1; // quit
			break;
			default:
			break;
		}
	} while(key!=KEY_CTRL_EXE && key!=KEY_CTRL_EXIT);
	return (key==KEY_CTRL_EXE && choice==1);
	// true : quit / false : resume
}




//****************************************************************************
//**************                                              ****************
//**************                 Notice!                      ****************
//**************                                              ****************
//**************  Please do not change the following source.  ****************
//**************                                              ****************
//****************************************************************************


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section


#pragma section _TOP

//****************************************************************************
//  InitializeSystem
//
//  param   :   isAppli   : 1 = Application / 0 = eActivity
//              OptionNum : Option Number (only eActivity)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int InitializeSystem(int isAppli, unsigned short OptionNum)
{
	return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section

