#ifndef PLANETS_H
#define PLANETS_H

#include <fxlib.h>
#include <stdlib.h>

#include "display.h"

#define NB_PLANETS 9

typedef enum planets {MERCURY, VENUS, EARTH, MARS, JUPITER, SATURN, URANUS, NEPTUNE };

typedef struct {
	unsigned char *name;
	int diameter; // km
	int distanceSun; // Mm (megametre)
	int temperature; // °C
	float mass; // 10E23 kg
	float density; // gm/cm3
	float gravity; // earth=1
} planet;

extern const planet Planets[9];

void showInfos(unsigned int indP);

#endif // PLANETS_H